<?php
/**
 * @subpackage  mod_xiroweb_art_nextlastlatest
 *
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 */

defined('_JEXEC') or die;

use Joomla\CMS\HTML\HTMLHelper;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Factory;

$wa = Factory::getApplication()->getDocument()->getWebAssetManager();
$css = '
    .fs-small-1 {
        font-size: 0.75em;
    }
    ul.nextlastlatest span {
        padding-right: 0.6rem;
    }
';
$wa->addInlineStyle($css);
?>
<?php foreach ($list as $key => $items) : ?>
    <?php if (($key == 'latest') && !empty($items)) : ?>
        <?php if ($params->get('show_latest_label', 1)) : ?>
            <h4>
                <?php if ($params->get('show_text_latest_label', 0)) : ?>
                    <?php echo htmlspecialchars($params->get('text_latest_label', ''), ENT_QUOTES, 'UTF-8'); ?>
                <?php else : ?>
                    <?php echo Text::_('MOD_XIROWEB_ART_NEXTLASTLATEST_TEXT_LATEST_LABEL'); ?>
                <?php endif; ?>
            </h4>
        <?php endif; ?>
    <?php endif; ?>
    <?php if (($key == 'next') && !empty($items)) : ?>
        <?php if ($params->get('show_next_label', 1)) : ?>
            <h4>
                <?php if ($params->get('show_text_next_label', 0)) : ?>
                    <?php echo htmlspecialchars($params->get('text_next_label', ''), ENT_QUOTES, 'UTF-8'); ?>
                <?php else : ?>
                    <?php echo Text::_('MOD_XIROWEB_ART_NEXTLASTLATEST_TEXT_NEXT_LABEL'); ?>
                <?php endif; ?>
            </h4>
        <?php endif; ?>
    <?php endif; ?>
    <?php if (($key == 'last')  && !empty($items)) : ?>
        <?php if ($params->get('show_last_label', 1)) : ?>
            <h4>
                <?php if ($params->get('show_text_last_label', 0)) : ?>
                    <?php echo htmlspecialchars($params->get('text_last_label', ''), ENT_QUOTES, 'UTF-8'); ?>
                <?php else : ?>
                    <?php echo Text::_('MOD_XIROWEB_ART_NEXTLASTLATEST_TEXT_LAST_LABEL'); ?>
                <?php endif; ?>
            </h4>
        <?php endif; ?>
    <?php endif; ?>
    <?php if (!empty($items)) : ?>
        <ul class="nextlastlatest <?php echo $key; ?>">
            <?php foreach ($items as $item) : ?>
                <li class="item">
                        <span>
                                <?php $attributes = ['class' => 'title ' . $item->active]; ?>
                                <?php $link = htmlspecialchars($item->link, ENT_COMPAT, 'UTF-8', false); ?>
                                <?php $title = htmlspecialchars($item->title, ENT_COMPAT, 'UTF-8', false); ?>
                                <?php echo HTMLHelper::_('link', $link, $title, $attributes); ?>
                        </span>
                        <?php if ($item->displayHits) : ?>
                            <span class=" fs-small-1">
                                <?php echo Text::_('JGLOBAL_HITS') . ': ' ; ?>
                                <?php echo $item->displayHits; ?>
                            </span>
                        <?php endif; ?>
                        <?php if ($params->get('show_author')) : ?>
                            <span class=" fs-small-1">
                                <?php echo Text::_('JAUTHOR') . ': ' ; ?>
                                <?php echo $item->displayAuthorName; ?>
                            </span>
                        <?php endif; ?>
                        <?php if ($item->displayCategoryTitle) : ?>
                            <span class=" fs-small-1">
                                <?php echo Text::_('JCATEGORY') . ': ' ; ?>
                                <?php echo $item->displayCategoryTitle; ?>
                            </span>
                        <?php endif; ?>
                        <?php if ($item->displayDate) : ?>
                            <span class=" fs-small-1">
                                <?php // echo Text::_('JGLOBAL_FIELD_CREATED_LABEL') . ': '; ?>
                                <?php echo $item->displayDate; ?>
                            </span>
                        <?php endif; ?>
                </li>
            <?php endforeach; ?>
        </ul>
        <?php endif; ?>
<?php endforeach; ?>
